defmodule DecentralisedBookIndex.Sync.DataTransformers.BookTransformer do
  def from_json(json_body) do
    json_body =
      if Map.has_key?(json_body, "data") do
        json_body["data"]
      else
        json_body
      end

    attrs =
      %{
        id: get_in(json_body, ["id"]),
        title: get_in(json_body, ["attributes", "title"]),
        description: get_in(json_body, ["attributes", "description"]),
        cover_image_url: get_in(json_body, ["attributes", "cover_image_url"]),
        format: get_in(json_body, ["attributes", "format"]),
        language: get_in(json_body, ["attributes", "language"]),
        published: get_in(json_body, ["attributes", "published"]),
        page_count: get_in(json_body, ["attributes", "page_count"]),
        publisher_id: get_in(json_body, ["attributes", "publisher_id"]),
        inserted_at: get_in(json_body, ["attributes", "inserted_at"]),
        updated_at: get_in(json_body, ["attributes", "updated_at"]),
        # relationship
        publisher_id: get_in(json_body, ["attributes", "publisher_id"]),
        # relationship
        dbi_server_id: get_in(json_body, ["attributes", "dbi_server_id"])
      }

    {:ok, attrs}
  end
end
